'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; // Based on https://github.com/gaearon/redux-devtools-log-monitor/blob/master/src/LogMonitorButton.js

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _shallowCompare = require('react/lib/shallowCompare');

var _shallowCompare2 = _interopRequireDefault(_shallowCompare);

var _reduxDevtoolsThemes = require('redux-devtools-themes');

var themes = _interopRequireWildcard(_reduxDevtoolsThemes);

var _brighten = require('redux-devtools-log-monitor/lib/brighten');

var _brighten2 = _interopRequireDefault(_brighten);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Button = class Button extends _react2.default.Component {

  constructor(props) {
    super(props);

    this.handleMouseEnter = this.handleMouseEnter.bind(this);
    this.handleMouseLeave = this.handleMouseLeave.bind(this);
    this.onClick = this.onClick.bind(this);

    this.state = {
      hovered: false
    };
  }

  shouldComponentUpdate(nextProps, nextState) {
    return (0, _shallowCompare2.default)(this, nextProps, nextState);
  }

  onClick() {
    if (!this.props.enabled) {
      return;
    }
    if (this.props.onClick) {
      this.props.onClick();
    }
  }

  handleMouseEnter() {
    this.setState({ hovered: true });
  }

  handleMouseLeave() {
    this.setState({ hovered: false });
  }

  render() {
    const { theme, enabled, href, download, Icon, children, onMouseDown, onMouseUp } = this.props;
    let style = _extends({}, _styles2.default.button, {
      backgroundColor: theme.base02
    });
    if (enabled && this.state.hovered) {
      style = _extends({}, style, {
        backgroundColor: (0, _brighten2.default)(theme.base02, 0.2)
      });
    }
    if (!enabled) {
      style = _extends({}, style, {
        opacity: 0.2,
        cursor: 'text',
        backgroundColor: 'transparent'
      });
    }
    return _react2.default.createElement(
      'a',
      { onMouseEnter: this.handleMouseEnter,
        onMouseLeave: this.handleMouseLeave,
        onMouseDown: onMouseDown,
        onMouseUp: onMouseUp,
        onClick: this.onClick,
        href: href,
        download: download,
        style: style
      },
      _react2.default.createElement(Icon, null),
      children && _react2.default.createElement(
        'span',
        { style: _styles2.default.buttonText },
        children
      )
    );
  }
};
Button.propTypes = {
  enabled: _react.PropTypes.bool,
  href: _react.PropTypes.string,
  download: _react.PropTypes.string,
  onClick: _react.PropTypes.func,
  onMouseDown: _react.PropTypes.func,
  onMouseUp: _react.PropTypes.func,
  Icon: _react.PropTypes.func.isRequired,
  children: _react.PropTypes.node,
  theme: _react.PropTypes.oneOfType([_react.PropTypes.object, _react.PropTypes.string])
};
Button.defaultProps = {
  theme: themes.nicinabox,
  enabled: true
};
exports.default = Button;
module.exports = exports['default'];