'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _shallowCompare = require('react/lib/shallowCompare');

var _shallowCompare2 = _interopRequireDefault(_shallowCompare);

var _actions = require('../actions');

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Instances = class Instances extends _react.Component {

  shouldComponentUpdate(nextProps) {
    return (0, _shallowCompare2.default)(this, nextProps);
  }

  render() {
    this.select = [['Autoselect instances', null]];
    const instances = this.props.instances;
    let name;
    Object.keys(instances).forEach(key => {
      name = instances[key].name;
      if (name !== undefined) this.select.push([instances[key].name, key]);
    });

    return _react2.default.createElement(
      _SelectField2.default,
      {
        style: _styles2.default.select,
        labelStyle: _styles2.default.selectLabel,
        iconStyle: _styles2.default.selectIcon,
        onChange: this.props.onSelect,
        value: this.props.selected
      },
      this.select.map(option => _react2.default.createElement(_MenuItem2.default, { key: option[1], value: option[1], primaryText: option[0] }))
    );
  }
};
Instances.propTypes = {
  selected: _react.PropTypes.string,
  instances: _react.PropTypes.object.isRequired,
  onSelect: _react.PropTypes.func.isRequired
};


function mapStateToProps(state) {
  return {
    instances: state.instances.options
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onSelect: (0, _redux.bindActionCreators)(_actions.selectInstance, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Instances);
module.exports = exports['default'];