'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _getMonitor = require('../utils/getMonitor');

var _actions = require('../actions');

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let MonitorSelector = class MonitorSelector extends _react.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.items = _getMonitor.monitors.map((item, i) => _react2.default.createElement(_MenuItem2.default, { key: i, value: item.key, primaryText: item.title })), _temp;
  }

  shouldComponentUpdate(nextProps) {
    return nextProps.selected !== this.props.selected;
  }

  render() {
    return _react2.default.createElement(
      _SelectField2.default,
      {
        style: _styles2.default.select,
        labelStyle: _styles2.default.selectLabel,
        iconStyle: _styles2.default.selectIcon,
        onChange: this.props.selectMonitor,
        value: this.props.selected || 'InspectorMonitor'
      },
      this.items
    );
  }
};
MonitorSelector.propTypes = {
  selected: _react.PropTypes.string,
  selectMonitor: _react.PropTypes.func.isRequired
};


function mapDispatchToProps(dispatch) {
  return {
    selectMonitor: (0, _redux.bindActionCreators)(_actions.selectMonitor, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(MonitorSelector);
module.exports = exports['default'];