'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _reduxDevtoolsThemes = require('redux-devtools-themes');

var themes = _interopRequireWildcard(_reduxDevtoolsThemes);

var _actions = require('../actions');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Notification = class Notification extends _react.Component {

  shouldComponentUpdate(nextProps) {
    return nextProps.notification !== this.props.notification;
  }

  render() {
    if (!this.props.notification) return null;
    const theme = themes.nicinabox;
    const buttonStyle = {
      color: theme.base06, backgroundColor: theme.base00,
      margin: '0', background: '#DC2424'
    };
    const containerStyle = {
      color: theme.base06, background: '#FC2424',
      padding: '5px 10px', minHeight: '20px', display: 'flex'
    };
    return _react2.default.createElement(
      'div',
      { style: containerStyle },
      _react2.default.createElement(
        'div',
        { style: { flex: '1', alignItems: 'center' } },
        _react2.default.createElement(
          'p',
          { style: { margin: '0px' } },
          this.props.notification.message
        )
      ),
      _react2.default.createElement(
        'div',
        { style: { alignItems: 'center' } },
        _react2.default.createElement(
          'button',
          {
            onClick: this.props.clearNotification,
            style: buttonStyle
          },
          '\xD7'
        )
      )
    );
  }
};
Notification.propTypes = {
  notification: _react.PropTypes.shape({
    message: _react.PropTypes.string,
    type: _react.PropTypes.string
  }),
  clearNotification: _react.PropTypes.func.isRequired
};


function mapStateToProps(state) {
  return {
    notification: state.notification
  };
}

function mapDispatchToProps(dispatch) {
  return {
    clearNotification: (0, _redux.bindActionCreators)(_actions.clearNotification, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Notification);
module.exports = exports['default'];