'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _keyboard = require('react-icons/lib/md/keyboard');

var _keyboard2 = _interopRequireDefault(_keyboard);

var _keyboardHide = require('react-icons/lib/md/keyboard-hide');

var _keyboardHide2 = _interopRequireDefault(_keyboardHide);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let DispatcherButton = class DispatcherButton extends _react.Component {

  shouldComponentUpdate(nextProps) {
    return nextProps.dispatcherIsOpen !== this.props.dispatcherIsOpen;
  }

  render() {
    return _react2.default.createElement(
      _Button2.default,
      {
        Icon: this.props.dispatcherIsOpen ? _keyboardHide2.default : _keyboard2.default,
        onClick: this.props.toggleDispatcher
      },
      'Dispatcher'
    );
  }
};
DispatcherButton.propTypes = {
  dispatcherIsOpen: _react.PropTypes.bool,
  toggleDispatcher: _react.PropTypes.func.isRequired
};


function mapDispatchToProps(dispatch) {
  return {
    toggleDispatcher: (0, _redux.bindActionCreators)(_actions.toggleDispatcher, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(DispatcherButton);
module.exports = exports['default'];