'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _fileUpload = require('react-icons/lib/md/file-upload');

var _fileUpload2 = _interopRequireDefault(_fileUpload);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let ImportButton = class ImportButton extends _react.Component {

  constructor() {
    super();
    this.handleImport = this.handleImport.bind(this);
    this.handleImportFile = this.handleImportFile.bind(this);
    this.mapRef = this.mapRef.bind(this);
  }

  shouldComponentUpdate() {
    return false;
  }

  mapRef(node) {
    this.fileInput = node;
  }

  handleImport() {
    this.fileInput.click();
  }

  handleImportFile(e) {
    const file = e.target.files[0];
    const reader = new FileReader();
    reader.onload = () => {
      this.props.importState(reader.result);
    };
    reader.readAsText(file);
    e.target.value = '';
  }

  render() {
    return _react2.default.createElement(
      _Button2.default,
      { Icon: _fileUpload2.default, onClick: this.handleImport },
      'Import',
      _react2.default.createElement('input', {
        type: 'file', ref: this.mapRef, style: { display: 'none' },
        onChange: this.handleImportFile
      })
    );
  }
};
ImportButton.propTypes = {
  importState: _react.PropTypes.func.isRequired,
  showNotification: _react.PropTypes.func.isRequired
};


function mapDispatchToProps(dispatch) {
  return {
    importState: (0, _redux.bindActionCreators)(_actions.importState, dispatch),
    showNotification: (0, _redux.bindActionCreators)(_actions.showNotification, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(ImportButton);
module.exports = exports['default'];