'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _lock = require('react-icons/lib/md/lock');

var _lock2 = _interopRequireDefault(_lock);

var _lockOpen = require('react-icons/lib/md/lock-open');

var _lockOpen2 = _interopRequireDefault(_lockOpen);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let LockButton = class LockButton extends _react.Component {

  shouldComponentUpdate(nextProps) {
    return nextProps.locked !== this.props.locked;
  }

  render() {
    return _react2.default.createElement(
      _Button2.default,
      {
        Icon: this.props.locked ? _lock2.default : _lockOpen2.default,
        onClick: this.props.lockChanges
      },
      this.props.locked ? 'Unlock changes' : 'Lock changes'
    );
  }
};
LockButton.propTypes = {
  locked: _react.PropTypes.bool,
  lockChanges: _react.PropTypes.func.isRequired
};


function mapDispatchToProps(dispatch, ownProps) {
  return {
    lockChanges: () => dispatch((0, _actions.lockChanges)(!ownProps.locked))
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(LockButton);
module.exports = exports['default'];