'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _fiberManualRecord = require('react-icons/lib/md/fiber-manual-record');

var _fiberManualRecord2 = _interopRequireDefault(_fiberManualRecord);

var _pauseCircleFilled = require('react-icons/lib/md/pause-circle-filled');

var _pauseCircleFilled2 = _interopRequireDefault(_pauseCircleFilled);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let RecordButton = class RecordButton extends _react.Component {

  shouldComponentUpdate(nextProps) {
    return nextProps.paused !== this.props.paused;
  }

  render() {
    return _react2.default.createElement(
      _Button2.default,
      {
        Icon: this.props.paused ? _fiberManualRecord2.default : _pauseCircleFilled2.default,
        onClick: this.props.pauseRecording
      },
      this.props.paused ? 'Start recording' : 'Pause recording'
    );
  }
};
RecordButton.propTypes = {
  paused: _react.PropTypes.bool,
  pauseRecording: _react.PropTypes.func.isRequired
};


function mapDispatchToProps(dispatch, ownProps) {
  return {
    pauseRecording: () => dispatch((0, _actions.pauseRecording)(!ownProps.paused))
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(RecordButton);
module.exports = exports['default'];