'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _getMonitor = require('../utils/getMonitor');

var _getMonitor2 = _interopRequireDefault(_getMonitor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let DevTools = class DevTools extends _react.Component {
  constructor(props) {
    super(props);

    this.dispatch = action => {
      this.props.dispatch(action);
    };

    this.getMonitor(props);
  }

  getMonitor(props) {
    const monitorElement = (0, _getMonitor2.default)(props);
    this.monitorProps = monitorElement.props;
    this.Monitor = monitorElement.type;

    const update = this.Monitor.update;
    if (update) {
      let newMonitorState;
      const monitorState = props.monitorState;
      if (monitorState && monitorState.__overwritten__ === props.monitor) {
        newMonitorState = monitorState;
      } else {
        newMonitorState = update(this.monitorProps, undefined, {});
        if (newMonitorState !== monitorState) {
          this.preventRender = true;
        }
      }
      this.dispatch({
        type: '@@INIT_MONITOR',
        newMonitorState,
        update,
        monitorProps: this.monitorProps
      });
    }
  }

  componentWillUpdate(nextProps) {
    if (nextProps.monitor !== this.props.monitor || nextProps.lib !== this.props.lib) this.getMonitor(nextProps);
  }

  shouldComponentUpdate(nextProps) {
    return nextProps.monitor !== this.props.monitor || nextProps.liftedState !== this.props.liftedState || nextProps.monitorState !== this.props.liftedState || nextProps.lib !== this.props.lib;
  }

  render() {
    if (this.preventRender) {
      this.preventRender = false;
      return null;
    }

    const liftedState = _extends({}, this.props.liftedState, {
      monitorState: this.props.monitorState
    });
    return _react2.default.createElement(this.Monitor, _extends({
      dispatch: this.dispatch
    }, liftedState, this.monitorProps));
  }
};
exports.default = DevTools;


DevTools.propTypes = {
  liftedState: _react.PropTypes.object,
  monitorState: _react.PropTypes.object,
  dispatch: _react.PropTypes.func.isRequired,
  monitor: _react.PropTypes.string,
  lib: _react.PropTypes.string
};
module.exports = exports['default'];