'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tooltipOptions = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getPath = getPath;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _reduxDevtoolsChartMonitor = require('redux-devtools-chart-monitor');

var _reduxDevtoolsChartMonitor2 = _interopRequireDefault(_reduxDevtoolsChartMonitor);

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const tooltipOptions = exports.tooltipOptions = {
  style: {
    'background-color': '#ffffff',
    'color': '#000000',
    'opacity': '0.9',
    'border-radius': '5px',
    'padding': '5px'
  }
};

function getPath(obj, inspectedStatePath) {
  const parent = obj.parent;
  if (!parent) return;
  getPath(parent, inspectedStatePath);
  let name = obj.name;
  const item = name.match(/.+\[(\d+)]/);
  if (item) name = item[1];
  inspectedStatePath.push(name);
}

let ChartMonitorWrapper = class ChartMonitorWrapper extends _react.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.onClickText = data => {
      const inspectedStatePath = [];
      getPath(data, inspectedStatePath);
      this.props.selectMonitorWithState('InspectorMonitor', {
        inspectedStatePath,
        tabName: 'State',
        subTabName: data.children ? 'Chart' : 'Tree',
        selectedActionId: null,
        startActionId: null,
        inspectedActionPath: []
      });
    }, _temp;
  }

  render() {
    return _react2.default.createElement(_reduxDevtoolsChartMonitor2.default, _extends({
      defaultIsVisible: true, invertTheme: true,
      tooltipOptions: tooltipOptions,
      onClickText: this.onClickText
    }, this.props));
  }
};
ChartMonitorWrapper.update = _reduxDevtoolsChartMonitor2.default.update;


ChartMonitorWrapper.propTypes = {
  selectMonitorWithState: _react.PropTypes.func.isRequired
};

function mapDispatchToProps(dispatch) {
  return {
    selectMonitorWithState: (0, _redux.bindActionCreators)(_actions.selectMonitorWithState, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(ChartMonitorWrapper);