'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _d3StateVisualizer = require('d3-state-visualizer');

var _ChartMonitorWrapper = require('../ChartMonitorWrapper');

var _actions = require('../../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const style = {
  width: '100%',
  height: '100%'
};

const defaultOptions = {
  heightBetweenNodesCoeff: 1,
  widthBetweenNodesCoeff: 1.3,
  tooltipOptions: _extends({}, _ChartMonitorWrapper.tooltipOptions, {
    offset: { left: 30, top: 10 },
    indentationSize: 2
  }),
  style: {
    width: '100%',
    height: '100%',
    node: {
      colors: {
        'default': '#A1C659',
        collapsed: '#A1C659',
        parent: '#D381C3'
      },
      radius: 7
    },
    text: {
      colors: {
        'default': '#6FB3D2',
        hover: '#FFFFFF'
      }
    }
  }
};

let ChartTab = class ChartTab extends _react.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.getRef = node => {
      this.node = node;
    }, this.onClickText = data => {
      const inspectedStatePath = [];
      (0, _ChartMonitorWrapper.getPath)(data, inspectedStatePath);
      this.props.updateMonitorState({
        inspectedStatePath,
        subTabName: data.children ? 'Chart' : 'Tree'
      });
    }, _temp;
  }

  componentDidMount() {
    this.renderChart = (0, _d3StateVisualizer.tree)(this.node, _extends({}, defaultOptions, { onClickText: this.onClickText }));
    this.renderChart(this.props.data);
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.data !== this.props.data) {
      this.renderChart(nextProps.data);
    }
  }

  render() {
    return _react2.default.createElement('div', { style: style, ref: this.getRef });
  }
};


ChartTab.propTypes = {
  data: _react.PropTypes.object,
  updateMonitorState: _react.PropTypes.func.isRequired
};

function mapDispatchToProps(dispatch) {
  return {
    updateMonitorState: (0, _redux.bindActionCreators)(_actions.updateMonitorState, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(null, mapDispatchToProps)(ChartTab);
module.exports = exports['default'];