'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _remotedevMonitorComponents = require('remotedev-monitor-components');

var _StateTab = require('remotedev-inspector-monitor/lib/tabs/StateTab');

var _StateTab2 = _interopRequireDefault(_StateTab);

var _ActionTab = require('remotedev-inspector-monitor/lib/tabs/ActionTab');

var _ActionTab2 = _interopRequireDefault(_ActionTab);

var _DiffTab = require('remotedev-inspector-monitor/lib/tabs/DiffTab');

var _DiffTab2 = _interopRequireDefault(_DiffTab);

var _actions = require('../../../actions');

var _RawTab = require('./RawTab');

var _RawTab2 = _interopRequireDefault(_RawTab);

var _ChartTab = require('./ChartTab');

var _ChartTab2 = _interopRequireDefault(_ChartTab);

var _VisualDiffTab = require('./VisualDiffTab');

var _VisualDiffTab2 = _interopRequireDefault(_VisualDiffTab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let SubTabs = class SubTabs extends _react.Component {
  constructor(props) {
    super(props);

    this.selector = () => {
      switch (this.props.parentTab) {
        case 'Action':
          return { data: this.props.action };
        case 'Diff':
          return { data: this.props.delta };
        default:
          return { data: this.props.nextState };
      }
    };

    this.updateTabs(props);
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.parentTab !== this.props.parentTab) {
      this.updateTabs(nextProps);
    }
  }

  updateTabs(props) {
    const parentTab = props.parentTab;

    if (parentTab === 'Diff') {
      this.tabs = [{
        name: 'Tree',
        component: _DiffTab2.default,
        selector: () => this.props
      }, {
        name: 'Raw',
        component: _VisualDiffTab2.default,
        selector: this.selector
      }];
      return;
    }

    this.tabs = [{
      name: 'Tree',
      component: parentTab === 'Action' ? _ActionTab2.default : _StateTab2.default,
      selector: () => this.props
    }, {
      name: 'Chart',
      component: _ChartTab2.default,
      selector: this.selector
    }, {
      name: 'Raw',
      component: _RawTab2.default,
      selector: this.selector
    }];
  }

  render() {
    let selected = this.props.selected;
    if (selected === 'Chart' && this.props.parentTab === 'Diff') selected = 'Tree';

    return _react2.default.createElement(_remotedevMonitorComponents.Tabs, {
      tabs: this.tabs,
      selected: selected,
      onClick: this.props.selectMonitorTab
    });
  }
};


SubTabs.propTypes = {
  selected: _react.PropTypes.string,
  parentTab: _react.PropTypes.string,
  selectMonitorTab: _react.PropTypes.func.isRequired,
  action: _react.PropTypes.object,
  delta: _react.PropTypes.object,
  nextState: _react.PropTypes.object
};

function mapStateToProps(state) {
  return {
    parentTab: state.monitor.monitorState.tabName,
    selected: state.monitor.monitorState.subTabName
  };
}

function mapDispatchToProps(dispatch) {
  return {
    selectMonitorTab: (0, _redux.bindActionCreators)(_actions.selectMonitorTab, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(SubTabs);
module.exports = exports['default'];