'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _styles = require('../../../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let TestForm = class TestForm extends _react.Component {
  constructor(props) {
    super(props);

    this.handleInputChange = (e, value) => {
      this.template[e.target.id] = value;
    };

    this.save = () => {
      this.props.onSave(this.template);
    };

    if (props.dialogStatus === 1) this.template = _extends({}, this.props.template);else this.template = {};
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.dialogStatus === 1) this.template = _extends({}, nextProps.template);
  }

  render() {
    const { onClose, onRemove, dialogStatus } = this.props;
    let template = {};
    if (dialogStatus === 1) template = this.props.template;
    const { name, assertion, dispatcher, wrap } = template;
    const actions = [_react2.default.createElement(_FlatButton2.default, {
      label: 'Cancel',
      primary: true,
      onTouchTap: onClose,
      labelStyle: _styles2.default.buttonLabel,
      style: _styles2.default.flatButton
    }), _react2.default.createElement(_FlatButton2.default, {
      label: dialogStatus === 1 ? 'Save' : 'Add',
      primary: true, keyboardFocused: true,
      onTouchTap: this.save,
      labelStyle: _styles2.default.buttonLabel,
      style: _styles2.default.flatButton
    })];
    if (dialogStatus === 1) {
      actions.splice(1, 0, _react2.default.createElement(_FlatButton2.default, {
        label: 'Remove',
        primary: true,
        onTouchTap: onRemove,
        labelStyle: _styles2.default.buttonLabel,
        style: _styles2.default.flatButton
      }));
    }

    return _react2.default.createElement(
      _Dialog2.default,
      {
        title: dialogStatus === 1 ? 'Edit template' : 'Add new template',
        actions: actions,
        modal: false,
        open: !!dialogStatus,
        onRequestClose: onClose,
        titleStyle: _styles2.default.dialogTitle,
        autoScrollBodyContent: true
      },
      _react2.default.createElement(_TextField2.default, {
        id: 'name',
        floatingLabelText: 'Template name',
        defaultValue: name,
        fullWidth: true,
        inputStyle: _styles2.default.input,
        onChange: this.handleInputChange
      }),
      _react2.default.createElement(_TextField2.default, {
        id: 'dispatcher',
        rows: 2,
        rowsMax: 2,
        floatingLabelText: 'Dispatcher template',
        hintText: '({ action, prevState }) => (`<template>`)',
        hintStyle: _styles2.default.hint,
        inputStyle: _styles2.default.input,
        defaultValue: dispatcher,
        multiLine: true, fullWidth: true,
        onChange: this.handleInputChange
      }),
      _react2.default.createElement(_TextField2.default, {
        id: 'assertion',
        rows: 2,
        rowsMax: 2,
        floatingLabelText: 'Assertion template',
        hintText: '({ curState }) => (`<template>`)',
        hintStyle: _styles2.default.hint,
        inputStyle: _styles2.default.input,
        defaultValue: assertion,
        multiLine: true, fullWidth: true,
        onChange: this.handleInputChange
      }),
      _react2.default.createElement(_TextField2.default, {
        id: 'wrap',
        rows: 5,
        rowsMax: 5,
        floatingLabelText: 'Wrapping template',
        hintText: '({ name, initialState, assertions }) => (`<template>`)',
        hintStyle: _styles2.default.hint,
        inputStyle: _styles2.default.input,
        defaultValue: wrap,
        multiLine: true, fullWidth: true,
        onChange: this.handleInputChange
      })
    );
  }
};
exports.default = TestForm;


TestForm.propTypes = {
  dialogStatus: _react.PropTypes.number,
  template: _react.PropTypes.object,
  onSave: _react.PropTypes.func,
  onRemove: _react.PropTypes.func,
  onClose: _react.PropTypes.func
};
module.exports = exports['default'];