'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
/*
import mochaVTemplate from 'redux-devtools-test-generator/lib/vanilla/mocha/template';
import tapeVTemplate from 'redux-devtools-test-generator/lib/vanilla/tape/template';
import avaVTemplate from 'redux-devtools-test-generator/lib/vanilla/ava/template';
*/


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _Button = require('../../../components/Button');

var _Button2 = _interopRequireDefault(_Button);

var _add = require('react-icons/lib/md/add');

var _add2 = _interopRequireDefault(_add);

var _edit = require('react-icons/lib/md/edit');

var _edit2 = _interopRequireDefault(_edit);

var _reduxDevtoolsTestGenerator = require('redux-devtools-test-generator');

var _reduxDevtoolsTestGenerator2 = _interopRequireDefault(_reduxDevtoolsTestGenerator);

var _template = require('redux-devtools-test-generator/lib/redux/jest/template');

var _template2 = _interopRequireDefault(_template);

var _template3 = require('redux-devtools-test-generator/lib/redux/mocha/template');

var _template4 = _interopRequireDefault(_template3);

var _template5 = require('redux-devtools-test-generator/lib/redux/tape/template');

var _template6 = _interopRequireDefault(_template5);

var _template7 = require('redux-devtools-test-generator/lib/redux/ava/template');

var _template8 = _interopRequireDefault(_template7);

var _actionTypes = require('../../../constants/actionTypes');

var _instances = require('../../../reducers/instances');

var _TestForm = require('./TestForm');

var _TestForm2 = _interopRequireDefault(_TestForm);

var _styles = require('../../../styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let TestTab = class TestTab extends _react.Component {
  constructor(props) {
    super(props);

    this.onSelect = (event, index, value) => {
      this.props.dispatch({ type: _actionTypes.TEST_SELECT, selected: value });
    };

    this.editTemplate = () => {
      this.setState({ dialogStatus: 1 });
    };

    this.addTemplate = () => {
      this.setState({ dialogStatus: 2 });
    };

    this.dispatch = action => {
      let templates;
      if (!this.props.templates) templates = this.getDefaultTemplates();
      this.props.dispatch(_extends({}, action, { templates }));
    };

    this.handleSave = template => {
      if (this.state.dialogStatus === 1) {
        this.dispatch({ type: _actionTypes.TEST_EDIT, template });
      } else {
        this.dispatch({ type: _actionTypes.TEST_ADD, template });
      }
      this.handleCloseDialog();
    };

    this.handleRemove = () => {
      // Todo: add snackbar with undo
      this.dispatch({ type: _actionTypes.TEST_REMOVE });
      this.handleCloseDialog();
    };

    this.handleCloseDialog = () => {
      this.setState({ dialogStatus: 0 });
    };

    this.state = { dialogStatus: 0 };
  }

  getDefaultTemplates() {
    /*
    if (this.props.options.lib === 'redux') {
      return [mochaTemplate, tapeTemplate, avaTemplate];
    }
    return [mochaVTemplate, tapeVTemplate, avaVTemplate];
    */
    return [_template2.default, _template4.default, _template6.default, _template8.default];
  }

  render() {
    const { dialogStatus } = this.state;
    const { selected } = this.props;
    const templates = this.props.templates || this.getDefaultTemplates();
    const template = templates[selected];
    const { assertion, dispatcher, wrap } = template;

    return _react2.default.createElement(_reduxDevtoolsTestGenerator2.default, _extends({
      isVanilla: this.props.options.lib !== 'redux',
      name: this.props.options.name,
      assertion: assertion, dispatcher: dispatcher, wrap: wrap,
      theme: 'night', useCodemirror: true,
      header: _react2.default.createElement(
        'div',
        { style: { height: '2.5em', minHeight: '2.5em', display: 'flex' } },
        _react2.default.createElement(
          _SelectField2.default,
          {
            style: _styles2.default.select,
            labelStyle: _styles2.default.selectLabel,
            iconStyle: _styles2.default.selectIcon,
            onChange: this.onSelect,
            value: selected
          },
          templates.map((item, i) => _react2.default.createElement(_MenuItem2.default, { key: i, value: i, primaryText: item.name }))
        ),
        _react2.default.createElement(_Button2.default, { Icon: _edit2.default, onClick: this.editTemplate }),
        _react2.default.createElement(_Button2.default, { Icon: _add2.default, onClick: this.addTemplate }),
        _react2.default.createElement(_TestForm2.default, {
          template, dialogStatus,
          onSave: this.handleSave,
          onRemove: this.handleRemove,
          onClose: this.handleCloseDialog
        })
      )
    }, this.props));
  }
};


TestTab.propTypes = {
  templates: _react.PropTypes.array,
  selected: _react.PropTypes.number,
  options: _react.PropTypes.object.isRequired,
  dispatch: _react.PropTypes.func.isRequired
};

function mapStateToProps(state) {
  const instances = state.instances;
  return {
    templates: state.test.templates,
    selected: state.test.selected,
    options: instances.options[(0, _instances.getActiveInstance)(instances)]
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps)(TestTab);
module.exports = exports['default'];