'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _remotedevInspectorMonitor = require('remotedev-inspector-monitor');

var _remotedevInspectorMonitor2 = _interopRequireDefault(_remotedevInspectorMonitor);

var _dataTypes = require('../../../constants/dataTypes');

var _SubTabs = require('./SubTabs');

var _SubTabs2 = _interopRequireDefault(_SubTabs);

var _TestTab = require('./TestTab');

var _TestTab2 = _interopRequireDefault(_TestTab);

var _StackTraceTab = require('./StackTraceTab');

var _StackTraceTab2 = _interopRequireDefault(_StackTraceTab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const DEFAULT_TABS = [{
  name: 'Action',
  component: _SubTabs2.default
}, {
  name: 'State',
  component: _SubTabs2.default
}, {
  name: 'Diff',
  component: _SubTabs2.default
}];

let InspectorWrapper = class InspectorWrapper extends _react.Component {

  render() {
    const _props = this.props,
          { lib } = _props,
          rest = _objectWithoutProperties(_props, ['lib']);
    let tabs;
    if (lib === 'redux') {
      tabs = () => [...DEFAULT_TABS, { name: "Stack", component: _StackTraceTab2.default }, { name: 'Test', component: _TestTab2.default }];
    } else {
      tabs = () => DEFAULT_TABS;
    }

    return _react2.default.createElement(_remotedevInspectorMonitor2.default, _extends({
      dataTypeKey: _dataTypes.DATA_TYPE_KEY,
      shouldPersistState: false,
      invertTheme: false,
      theme: 'nicinabox',
      tabs: tabs
    }, rest));
  }
};
InspectorWrapper.update = _remotedevInspectorMonitor2.default.update;


InspectorWrapper.propTypes = {
  lib: _react.PropTypes.string
};

exports.default = InspectorWrapper;
module.exports = exports['default'];