'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2015-present, Facebook, Inc.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                   * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                   */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('../styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const _preStyle = {
  position: 'relative',
  display: 'block',
  padding: '0.5em',
  marginTop: '0.5em',
  marginBottom: '0.5em',
  overflowX: 'auto',
  whiteSpace: 'pre-wrap',
  borderRadius: '0.25rem'
};

const primaryPreStyle = _extends({}, _preStyle, {
  backgroundColor: _styles.redTransparent
});

const secondaryPreStyle = _extends({}, _preStyle, {
  backgroundColor: _styles.yellowTransparent
});

const codeStyle = {
  fontFamily: 'Consolas, Menlo, monospace'
};

function CodeBlock(props) {
  const preStyle = props.main ? primaryPreStyle : secondaryPreStyle;
  const codeBlock = { __html: props.codeHTML };

  return _react2.default.createElement(
    'pre',
    { style: preStyle },
    _react2.default.createElement('code', { style: codeStyle, dangerouslySetInnerHTML: codeBlock })
  );
}

exports.default = CodeBlock;
module.exports = exports['default'];