'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * Copyright (c) 2015-present, Facebook, Inc.
                                                                                                                                                                                                                                                                   *
                                                                                                                                                                                                                                                                   * This source code is licensed under the MIT license found in the
                                                                                                                                                                                                                                                                   * LICENSE file in the root directory of this source tree.
                                                                                                                                                                                                                                                                   */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('../styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const _collapsibleStyle = {
  color: _styles.black,
  cursor: 'pointer',
  border: 'none',
  display: 'block',
  width: '100%',
  textAlign: 'left',
  background: '#fff',
  fontFamily: 'Consolas, Menlo, monospace',
  fontSize: '1em',
  padding: '0px',
  lineHeight: '1.5'
};

const collapsibleCollapsedStyle = _extends({}, _collapsibleStyle, {
  marginBottom: '1.5em'
});

const collapsibleExpandedStyle = _extends({}, _collapsibleStyle, {
  marginBottom: '0.6em'
});

let Collapsible = class Collapsible extends _react.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.state = {
      collapsed: true
    }, this.toggleCollaped = () => {
      this.setState(state => ({
        collapsed: !state.collapsed
      }));
    }, _temp;
  }

  render() {
    const count = this.props.children.length;
    const collapsed = this.state.collapsed;
    return _react2.default.createElement(
      'div',
      null,
      _react2.default.createElement(
        'button',
        {
          onClick: this.toggleCollaped,
          style: collapsed ? collapsibleCollapsedStyle : collapsibleExpandedStyle
        },
        (collapsed ? '▶' : '▼') + ` ${ count } stack frames were ` + (collapsed ? 'collapsed.' : 'expanded.')
      ),
      _react2.default.createElement(
        'div',
        { style: { display: collapsed ? 'none' : 'block' } },
        this.props.children,
        _react2.default.createElement(
          'button',
          {
            onClick: this.toggleCollaped,
            style: collapsibleExpandedStyle
          },
          `▲ ${ count } stack frames were expanded.`
        )
      )
    );
  }
};
exports.default = Collapsible;
module.exports = exports['default'];