'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTapEventPlugin = require('react-tap-event-plugin');

var _reactTapEventPlugin2 = _interopRequireDefault(_reactTapEventPlugin);

var _getMuiTheme = require('material-ui/styles/getMuiTheme');

var _getMuiTheme2 = _interopRequireDefault(_getMuiTheme);

var _MuiThemeProvider = require('material-ui/styles/MuiThemeProvider');

var _MuiThemeProvider2 = _interopRequireDefault(_MuiThemeProvider);

var _light = require('./themes/light');

var _light2 = _interopRequireDefault(_light);

var _dark = require('./themes/dark');

var _dark2 = _interopRequireDefault(_dark);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _reactTapEventPlugin2.default)();

const enhance = (ComposedComponent, isLightTheme) => {
  return class extends _react.Component {
    constructor(...args) {
      var _temp;

      return _temp = super(...args), this.theme = (0, _getMuiTheme2.default)(isLightTheme ? _light2.default : _dark2.default), _temp;
    }

    render() {
      return _react2.default.createElement(
        _MuiThemeProvider2.default,
        { muiTheme: this.theme },
        _react2.default.createElement(ComposedComponent, this.props)
      );
    }
  };
};

exports.default = enhance;
module.exports = exports['default'];