'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('remotedev-monitor-components/lib/presets');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _hoc = require('./hoc');

var _hoc2 = _interopRequireDefault(_hoc);

var _configureStore = require('./store/configureStore');

var _configureStore2 = _interopRequireDefault(_configureStore);

var _localStorage = require('./utils/localStorage');

var _socketActionTypes = require('./constants/socketActionTypes');

var _App = require('./containers/App');

var _App2 = _interopRequireDefault(_App);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let Root = class Root extends _react.Component {
  componentWillMount() {
    this.store = (0, _configureStore2.default)({
      monitor: (0, _localStorage.getMonitorSettings)() || this.props.monitorOptions,
      test: {
        selected: (0, _localStorage.getTemplatesSelected)(),
        templates: (0, _localStorage.getTestTemplates)() || this.props.testTemplates
      }
    });
    this.store.dispatch({
      type: _socketActionTypes.CONNECT_REQUEST,
      options: (0, _localStorage.getSocketSettings)() || this.props.socketOptions
    });
  }

  render() {
    return _react2.default.createElement(
      _reactRedux.Provider,
      { store: this.store },
      _react2.default.createElement(_App2.default, this.props)
    );
  }
};


Root.propTypes = {
  hash: _react.PropTypes.bool,
  socketOptions: _react.PropTypes.shape({
    hostname: _react.PropTypes.string,
    port: _react.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
    autoReconnect: _react.PropTypes.bool,
    secure: _react.PropTypes.bool
  }),
  monitorOptions: _react.PropTypes.shape({
    selected: _react.PropTypes.string
  }),
  testTemplates: _react.PropTypes.array
};

exports.default = (0, _hoc2.default)(Root);
module.exports = exports['default'];