'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = monitor;

var _actionTypes = require('../constants/actionTypes');

const initialState = {
  selected: 0,
  templates: undefined
};

function monitor(state = initialState, action) {
  let templates;
  switch (action.type) {
    case _actionTypes.TEST_SELECT:
      return _extends({}, state, { selected: action.selected });
    case _actionTypes.TEST_EDIT:
      templates = [...(state.templates || action.templates)];
      templates[state.selected] = action.template;
      return _extends({}, state, { templates });
    case _actionTypes.TEST_ADD:
      return _extends({}, state, {
        selected: state.templates.length,
        templates: [...(state.templates || action.templates), action.template]
      });
    case _actionTypes.TEST_REMOVE:
      templates = state.templates || action.templates;
      return _extends({}, state, {
        selected: 0,
        templates: templates.length === 1 ? undefined : [...templates.slice(0, state.selected), ...templates.slice(state.selected + 1)]
      });
    default:
      return state;
  }
}
module.exports = exports['default'];