'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = stringifyJSON;

var _jsan = require('jsan');

var _jsan2 = _interopRequireDefault(_jsan);

var _dataTypes = require('../constants/dataTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function replacer(key, value) {
  if (typeof value === 'object' && value !== null && _dataTypes.DATA_TYPE_KEY in value) {
    const __serializedType__ = value[_dataTypes.DATA_TYPE_KEY];
    delete value[_dataTypes.DATA_TYPE_KEY];
    const r = { data: value, __serializedType__ };
    if (_dataTypes.DATA_REF_KEY in value) r.__serializedRef__ = value[_dataTypes.DATA_REF_KEY];
    return r;
  }
  return value;
}

function stringifyJSON(data, serialize) {
  return serialize ? _jsan2.default.stringify(data, replacer, null, true) : _jsan2.default.stringify(data);
}
module.exports = exports['default'];